class NoSpam expands Actor config;

var bool bMapAnalyzed, bNeedDestroy;
var int NumPwn, Stepping, Ds;
var config int DesiredMonsters;

event PreBeginPlay()
{
	log (Self.Name$" loaded and started...");
	log ("Desired number has been set at"@DesiredMonsters);
	if (DesiredMonsters < 300)
		DesiredMonsters = 300;
//	SetTimer(Level.TimeDilation*3,False);
	if (!bMapAnalyzed)
	{
		DoAnalize();
//		SetTimer(Level.TimeDilation,False);
//		return;
	}
	if ( bNeedDestroy )
	{
		DoRemoval();
		SetTimer(Level.TimeDilation,False);
//		return;
	}
}

function DoAnalize()
{
	local Pawn P;

	Foreach AllActors( class 'Pawn',P ) //Debate all sort of shite including XPawn and so on
	{
		if ( P.PlayerReplicationInfo == None && P.Health > 0 )
		NumPwn++;
		if ( NumPwn > DesiredMonsters )
		{
			Stepping = Clamp(NumPwn/DesiredMonsters,1,NumPwn/DesiredMonsters);
			bNeedDestroy=True;
		}
	}
	if ( bNeedDestroy )
		log (Self$" reporting "$NumPwn$" creatures. Will allow a creature at each "$Stepping$" creatures aiming "$DesiredMonsters$" pieces." );
	bMapAnalyzed = True;
}

function DoRemoval()
{
	local Pawn P;
	local int Step;
	local Actor A;
	local bool bNotThis;
	local string ATag, AName;

	Foreach AllActors (class 'Pawn',P)
	{
		if ( P.PlayerReplicationInfo == None && P.Health > 0 )
		{
			if ( bNotThis )
				bNotThis = False;
			if ( ScriptedPawn(P) != None )
			{
				if ( ( ScriptedPawn(P).Orders == 'Patroling'
				|| ScriptedPawn(P).Orders == 'Guarding'
				|| ScriptedPawn(P).Orders == 'Ambushing' 
				|| ScriptedPawn(P).Orders == 'Sitting' )
				|| (ScriptedPawn(P).OrderTag != '') || (P.AlarmTag != '') || (P.SharedAlarmTag != '') )
					bNotThis=True;
				if ( ScriptedPawn(P).Orders != '' 
				|| ScriptedPawn(P).Orders != 'Guarding'
				|| ScriptedPawn(P).Orders != 'Ambushing' 
				|| ScriptedPawn(P).Orders != 'Sitting' )
				ScriptedPawn(P).Orders = 'Waiting';
			}
/*
//			log ( "Testing"@P@"with Tag"@P.Tag@"and Name"@P.Class.Name);
			if ( P.Tag != P.Class.Name )
			{
				log ("For Pawn"@P@"Tag and Class name doesn't match, LOL.");
				bNotThis = True;
//				ATag = CAPS(P.Tag);
//				AName = CAPS(P.Class.Name);
//				if ( ATag != AName )
//					log ("#2 Tag and class name doesn't match");
			}
*/
			if ( !bNotThis )
			if ( P.Event != '' )
			{
				foreach AllActors (class 'Actor', A, P.Event)
				{
					if ( A != None && A != P ) //Warning!
					{
						bNotThis = True;
						break;
					}
				}
			}
			if ( !bNotThis )
			{
				if ( Stepping > 0 && Step < Stepping  )
				{
//					P.Died(P,'',P.Location);
//					P.TakeDamage(1000000,None,P.Location,vect(0,0,0),'slashed'); //Crashing at 1639 creatures btw
					if ( P.Weapon != None )
						P.Weapon.LifeSpan = 0.100000;
//					P.Destroy();
					P.AmbientSound=None;
					P.Health=-1000;
					P.SetCollision(False,False,False);
					P.SetCollisionSize(0,0);
					P.LifeSpan=0.1+FRand();
					Ds++;
					NumPwn--;
					if ( NumPwn <= DesiredMonsters )
						break;
				}
				Step++;
				if ( Step > Stepping )
					Step=0;
			}
		}
	}
//	ConsoleCommand("OBJ GARBAGE");
//	ConsoleCommand("FLUSH");
	bNeedDestroy = False;
}

event Timer()
{
	if ( DeathMatchPlus(Level.Game) != None && DeathMatchPlus(Level.Game).bRequireReady )
		SetTimer(Level.TimeDilation*2,False);
	if ( DeathMatchPlus(Level.Game) != None && !DeathMatchPlus(Level.Game).bRequireReady )
	{
		BroadcastMessage(Ds@"creatures have been eliminated by Spam-Guard.");
		Destroy();
		return;
	}
}

defaultproperties
{
   bHidden=True
   RemoteRole=ROLE_None
}